<%
/* 
	Ejercicio:	3x2x08
	Fecha:		25/10/2012

	Enunciado:
		Implementa una página JSP que reciba un importe y visualice el desglose del cambio en
		unidades monetarias de céntimos de €, 1€, 2€, 5€, 10€, 50€. Ej. 58.9 = 1 billete de 50€,
		1 billete de 5 €, 3 monedas de 1€ y 90 céntimos de €.
*/
%>

<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<!DOCTYPE html>
<html>

	<head>
		<meta charset="UTF-8">
		<title>3x2x08</title>
		
		<style type="text/css">
			  table{ border-spacing: 40px; border: 1px solid black; }
			caption{ font-weight: bold;    font-size: 30px; }
		</style>		
	</head>

	<body>
		<%
		String parametro = request.getParameter("importe");
		
		if(parametro != null)
		{
			Float importe  = Float.parseFloat(parametro); 
			int   euros    = importe.intValue();
			Float redondeo = (float)Math.round((importe - euros) * 100) / 100;
			int   centimos = (int)((redondeo)*100);
			
			
			// Euros:
			int cincuentaEuros = euros / 50;
			int diezEuros      = euros % 50 / 10;
			int cincoEuros     = euros % 50 % 10 / 5;			
			int dosEuros       = euros % 50 % 10 % 5 / 2;
			int unEuro         = euros % 50 % 10 % 5 % 2 / 1;

			//Centimos: 
			int cincuentaCents = centimos / 50;
			int veinteCents    = centimos % 50 / 20;
			int diezCents      = centimos % 50 % 20 / 10;
			int cincoCents     = centimos % 50 % 20 % 10 / 5;
			int dosCents       = centimos % 50 % 20 % 10 % 5 / 2;
			int unCents        = centimos % 50 % 20 % 10 % 5 % 2 / 1;
			
			%>
			<table>
				<caption>Desglose de <% out.print(importe); %>€</caption>

				<tr>
					<td><b>Moneda / Billete</b></td>				
					<%
					if(cincuentaEuros != 0) out.print("<td>50</td>"); 
					if(diezEuros != 0)      out.print("<td>10</td>");
					if(cincoEuros != 0)     out.print("<td>5</td>");
					if(dosEuros != 0)       out.print("<td>2</td>");
					if(unEuro != 0)         out.print("<td>1</td>");
					if(cincuentaCents != 0) out.print("<td>0.50</td>");
					if(veinteCents != 0)    out.print("<td>0.20</td>");
					if(diezCents != 0)      out.print("<td>0.10</td>");
					if(cincoCents != 0)     out.print("<td>0.05</td>");
					if(dosCents != 0)       out.print("<td>0.02</td>");
					if(unCents != 0)        out.print("<td>0.01</td>");
					%>
				</tr>

				<tr>
					<td><b>Cantidad</b></td>
					<%
					if(cincuentaEuros != 0) out.print("<td>" + cincuentaEuros + "</td>"); 
					if(diezEuros != 0)      out.print("<td>" + diezEuros      + "</td>");
					if(cincoEuros != 0)     out.print("<td>" + cincoEuros     + "</td>");
					if(dosEuros != 0)       out.print("<td>" + dosEuros       + "</td>");
					if(unEuro != 0)         out.print("<td>" + unEuro         + "</td>");
					if(cincuentaCents != 0) out.print("<td>" + cincuentaCents + "</td>");
					if(veinteCents != 0)    out.print("<td>" + veinteCents    + "</td>");
					if(diezCents != 0)      out.print("<td>" + diezCents      + "</td>");
					if(cincoCents != 0)     out.print("<td>" + cincoCents     + "</td>");
					if(dosCents != 0)       out.print("<td>" + dosCents       + "</td>");
					if(unCents != 0)        out.print("<td>" + unCents        + "</td>");
					%>
				</tr>
				
			</table>			
			<%
		}
		else
		{
		%>
			<form action="3x2x08.jsp" method="get">
			<label>Introduzca un importe en euros: <i>(Ejemplo: 58.9)</i></label>
				<input type="number" name="importe" />
				<input type="submit" value="Enviar "/>			
			</form> 
		<%	
		}	
		%>	
	</body>
	
</html>