<%
/* 
	Ejercicio:	3x2x09
	Fecha:		26/10/2012

	Enunciado:
			Realizar página JSP que a partir de una cantidad en euros fija (en el ejemplo 337)
			muestre el cambio con relación a las otras monedas. Utilizar un vector para almacenar
			el tipo de moneda y su cambio.
			http://img.giltesa.com/images/559JSP3x2x09.png
*/
%>

<%@ page import="java.io.InputStreamReader" %>
<%@ page import="java.io.Reader" %>
<%@ page import="java.net.URL" %>
<%@ page import="com.google.gson.Gson" %>


<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<!DOCTYPE html>
<html>

	<head>
		<meta charset="UTF-8">
		<title>3x2x09</title>
		
		<style type="text/css">
			   table{ border: 1px solid black; }
			 caption{ font-weight: bold;  font-size: 20px; }
			  tr, td{ border-style:inset; border-width: 1px; }
		</style>		
	</head>

	<body>
		<%
		String parametro = request.getParameter("importe");
		
		if(parametro != null)
		{
			Float importe  = Float.parseFloat(parametro); 

			%>
			<table>
				<caption>Cantidad en euros = <% out.print(parametro); %></caption>

				<tr>
					<td><b>Moneda</b></td>				
					<td><b>Tasa de cambio</b></td>
					<td><b>Resultado</b></td>
				</tr>
				
				<tr>
					<!-- USD -->
					<td>Dólar Americano</td>
					<td><% out.print(conversorDivisas("EUR", "USD", Float.parseFloat("1") )); %></td> 
					<td><% out.print(conversorDivisas("EUR", "USD", importe)); %></td>
				</tr>
				
				<tr>
					<!-- AUD -->
					<td>Dólar Australiano</td> 
					<td><% out.print(conversorDivisas("EUR", "AUD", Float.parseFloat("1") )); %></td> 
					<td><% out.print(conversorDivisas("EUR", "AUD", importe)); %></td>
				</tr>
				
				<tr>
					<!-- CAD -->
					<td>Dólar Canadiense</td> 
					<td><% out.print(conversorDivisas("EUR", "CAD", Float.parseFloat("1") )); %></td> 
					<td><% out.print(conversorDivisas("EUR", "CAD", importe)); %></td>
				</tr>
				
				<tr>
					<!-- JPY -->
					<td>Yen Japonés</td> 
					<td><% out.print(conversorDivisas("EUR", "JPY", Float.parseFloat("1") )); %></td> 
					<td><% out.print(conversorDivisas("EUR", "JPY", importe)); %></td>
				</tr>
				
				<tr>
					<!-- CNY -->
					<td>Yuan chino</td> 
					<td><% out.print(conversorDivisas("EUR", "CNY", Float.parseFloat("1") )); %></td> 
					<td><% out.print(conversorDivisas("EUR", "CNY", importe)); %></td>
				</tr>
				
				<tr>
					<!-- RUB -->
					<td>Rublo Ruso</td> 
					<td><% out.print(conversorDivisas("EUR", "RUB", Float.parseFloat("1") )); %></td> 
					<td><% out.print(conversorDivisas("EUR", "RUB", importe)); %></td>
				</tr>
				
			</table>			
			<%
		}
		else
		{
		%>
			<form action="3x2x09.jsp" method="get">
			<label>Introduzca un importe en euros: <i>(Ejemplo: 337)</i></label>
				<input type="number" name="importe" />
				<input type="submit" value="Enviar "/>			
			</form> 
		<%	
		}	
		%>	
	</body>
	
</html>

<%!
	/**
	*
	* Conversor de moneda usando la API de Google
	*
	* @param String divisaOrigen  : Siglas de la moneda.
	* @param String divisaDestino : Siglas de la moenda.
	* @param float cantidad
	* @return Float
	*		
	* INFO: http://blog.caplin.com/2011/01/06/simple-currency-conversion-using-google-calculator-and-java/
	*		http://es.wikipedia.org/wiki/ISO_4217
	*	    http://www.w3schools.com/tags/ref_urlencode.asp
	*/
	String conversorDivisas( String divisaOrigen, String divisaDestino, Float cantidad) throws Exception
	{
	    String google = "http://www.google.com/ig/calculator?hl=en&q=" + cantidad + divisaOrigen + "=?" + divisaDestino;
	    String charset = "UTF-8";

	    URL url = new URL(google);
		Reader reader = new InputStreamReader(url.openStream(), charset);
		Result result = new Gson().fromJson(reader, Result.class);
		String resultado = result.getRhs().split("\\s+")[0];

		return resultado;
	};

	static class Result
	{
		private String lhs;
		private String rhs;
	
		public String getLhs(){return lhs;}
		public String getRhs(){return rhs;}
		public void setLhs(String lhs){this.lhs = lhs;}
		public void setRhs(String rhs){this.rhs = rhs;}
	}
%>