package paquetes;
import java.sql.*;
import java.util.ArrayList;
import java.util.Collection;
public class AccesoBdatos {
public Connection conecta;
	public void conectar() throws SQLException, ClassNotFoundException {
		Class.forName("com.mysql.jdbc.Driver");
		conecta = DriverManager.getConnection("jdbc:mysql://localhost:3306/demodb","root","");
	}
	public void insertar(Integer clave, String nombre, String localidad){
		try {
			String sql="insert into dept values (?,?,?)";
			PreparedStatement inserta=conecta.prepareStatement(sql);
			inserta.setInt(1,clave);
			inserta.setString(2,nombre);
			inserta.setString(3,localidad);
			inserta.executeUpdate();
		} catch(SQLException e){
			System.out.println("error al insertar en dept"+e.getMessage());
		}
	}
	
	public void insertarConBean(Depto registro){
		try {
		String sql="insert into dept values (?,?,?)";
		PreparedStatement inserta =conecta.prepareStatement(sql);
		inserta.setInt(1,registro.getDeptno());
		inserta.setString(2,registro.getDname());
		inserta.setString(3,registro.getLoc());
		inserta.executeUpdate();
		} catch(SQLException e){
		System.out.println("error al insertar en dept"+e.getMessage());
		}
		}
	public Collection consultarConBean(){
		ArrayList deptos = new ArrayList ();
		try {
		PreparedStatement consulta = conecta.prepareStatement("SELECT * FROM dept");
		ResultSet reg = consulta.executeQuery ();
		while (reg.next ()) {
		Depto departamento = new Depto(
		reg.getInt (1), reg.getString (2), reg.getString (3));
		deptos.add(departamento);
		}
		consulta.close ();
		} catch (SQLException e) {
		return null;
		} return deptos;
		}
	
	public Depto consultarUno(int numero){
		try {
		PreparedStatement consulta = conecta.prepareStatement("SELECT * FROM dept WHERE deptno=?");
		consulta.setInt(1, numero);
		ResultSet reg = consulta.executeQuery ();
		Depto departamento = new Depto();
		if (reg.next ())
		{
		departamento.setDeptno(reg.getInt (1));
		departamento.setDname(reg.getString(2));
		departamento.setLoc(reg.getString(3));
		}
		consulta.close ();
		return departamento;
		}
		catch (SQLException e) {
		System.out.println("error en la consulta"+e.getMessage());
		return null;
		}
		}
	
	public void actualizar(Depto registro){
		try {
		String sql="update dept set dname=?, loc=? where deptno=?";
		PreparedStatement actualiza = conecta.prepareStatement(sql);
		actualiza.setString(1,registro.getDname());
		actualiza.setString(2,registro.getLoc());
		actualiza.setInt(3,registro.getDeptno());
		actualiza.executeUpdate();
		} catch(SQLException e){
		System.out.println("error al actualizar en dept"+e.getMessage());
		}
		}
	public void bajas(int numero){ 
		try {
		PreparedStatement consulta = conecta.prepareStatement("DELETE FROM dept WHERE deptno=?");
		consulta.setInt(1, numero);
		consulta.executeUpdate();
		consulta.close ();
		} catch (SQLException e) {
		System.out.println("error en la consulta"+e.getMessage());
		}
		}
	public int bajas2(int numero){
		int filas=0;
		try {
		PreparedStatement baja = conecta.prepareStatement("DELETE FROM dept WHERE deptno=?");
		baja.setInt(1, numero);
		filas = baja.executeUpdate ();
		baja.close ();
		return filas;
		} catch (SQLException e) {
		System.out.println("error en la consulta"+e.getMessage());
		return 0;
		}
		}
	public void llamaProc(Integer clave, String localidad){
		try {
		CallableStatement actu = conecta.prepareCall("{call actualizaDept(?,?)}");
		actu.setInt(1,clave);
		actu.setString(2,localidad);
		actu.executeUpdate();
		} catch (SQLException e) {
		System.out.println("error en la actualizacin"+e.getMessage());
		}
		}
	public Depto consultarUnoProc(int numero){ try {
		CallableStatement consulta = conecta.prepareCall("{Call consultaDepar(?,?,?)}");
		consulta.setInt(1, numero);
		consulta.registerOutParameter(2, Types.VARCHAR);
		consulta.registerOutParameter(3, Types.VARCHAR);
		consulta.execute();
		Depto departamento = new Depto();
		departamento.deptno=numero;
		departamento.dname=consulta.getString(2);
		departamento.loc=consulta.getString(3);
		consulta.close ();
		return departamento;
		}
		catch (SQLException e) {
		System.out.println("error en la consulta"+e.getMessage());
		return null;
		}
		}
	/* Esto solo fue para probarlo independientemente
	public static void main(String[] args) throws ClassNotFoundException, SQLException{
		AccesoBdatos abd=new AccesoBdatos();
		abd.conectar();
		abd.insertar(60, "Nombre60", "Localidad 60");		
	} */
}